import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.servlet.*;
import java.servlet.http.*;
import java.servlet.html.*;

/**
 * @author  Pavani Diwanji
 */
public
class PhoneServlet extends GenericServlet { 
    private Hashtable phones;

    public void init() throws ServletException {
        int next;
        String name, number;

	super.init();
        log("PhoneServlet.initialize: enter");

        String fileName = getInitParameter("phonelist");
	if (fileName == null) {
	    return;
	}

        log("PhoneServlet.initialize: filename = " + fileName);

	try {
	    FileInputStream fin = new FileInputStream(fileName);
	    phones = new Hashtable();
	    StreamTokenizer st = new StreamTokenizer(fin);
	    st.eolIsSignificant(true);
	    st.slashSlashComments(true);

	    while ((next = st.nextToken()) != StreamTokenizer.TT_EOF) {
		switch (next) {
		  case StreamTokenizer.TT_WORD:
		    name = st.sval;
		    next = st.nextToken();
		    if (next != StreamTokenizer.TT_WORD) {
			throw new IOException("No phone for name: " + name);
		    }
		    number = st.sval;
		    break;
		  default:
		    continue;
		}
		phones.put(name, number);        
	    }
	} catch (IOException e) {
	    phones = null;
	}
    }

    public void service(ServletRequest req, ServletResponse res)
	throws ServletException, IOException
    {
	/*
	 * If the query is for a specific person then just return, else
	 * dump the whole extensions list
	 */
	res.setContentType("text/html");

	OutputStream out = res.getOutputStream();
	String title = "Phones";

	HtmlPage page = new HtmlPage(title);
	page.add(title, "H1");
   
	if (phones == null) {
	    page.add("No phone list");
	    page.write(out);
	    out.flush();
	    return;
	}
	String name = req.getParameter("name");
	if (name != null) {
	    String phone = (String) phones.get(name);
	    if (phone == null) phone = "Not listed";
	    page.add(name + ": " + phone);
	    page.write(out);
	    out.flush();
	    return;
	}
	page.add(phones.toString());
	page.write(out);
	out.flush();
    }

    public String getServletInfo() {
	return "This servlet is useful for looking up phone extensions.";
    }
}
